<?php
namespace App\Services;

use Yard;
use App\User;
use Illuminate\Support\Str;
use App\Models\PromotionUser;
use App\Models\ShippingCountry;

class UserService
{

    public static $user_country;
    public static $shipping_country;
    public static $shipping_free = false;
    public static $user_tax_free = false;
    public static $user_reverse_charge = false;

    public static function createConfirmationCode() {
        $unique = false;
        do{
            $confirmation_code = Str::random(30);
            if(User::where('confirmation_code', '=', $confirmation_code)->count() == 0){
                $unique = true;
            }
        }
        while(!$unique);
        return $confirmation_code;
    }

    public static function getTransChange(){

        $langs = config('localization.supportedLocales');
        $ret = [];
        foreach($langs as $code => $lang){
             $ret[strtolower($code)] = strtolower($lang['native']);
        }
        return $ret;
    }


    public static function initCustomerYard($shopping_user, $for){
        self::$user_tax_free = false;
        if($shopping_user->same_as_billing){
            self::$user_country = $shopping_user->billing_country;
            self::$shipping_country = $shopping_user->billing_country;
        }else{
            self::$user_country = $shopping_user->billing_country;
            self::$shipping_country = $shopping_user->shipping_country;
        }
        if(self::$user_country->supply_country && self::$shipping_country->supply_country){
            self::$user_tax_free = true;
        }
        $ShippingCountry = ShippingCountry::whereCountryId(self::$shipping_country->id)->first();
        self::$shipping_free = $ShippingCountry->shipping ? $ShippingCountry->shipping->free : false;
        self::$shipping_free = self::$shipping_free !== null ? self::$shipping_free : false;
        Yard::instance('shopping')->setShippingCountryWithPrice($ShippingCountry->id, $for);
        Yard::instance('shopping')->setUserPriceInfos(self::getYardInfo());
    }

    public static function initUserYard(User $user, $shipping_country_id, $for){
        self::$shipping_free = false;
        self::checkUserTaxShippingCountry($user, $shipping_country_id,);
        Yard::instance('shopping')->setShippingCountryWithPrice($shipping_country_id, $for);
        Yard::instance('shopping')->setUserPriceInfos(self::getYardInfo());
    }

   
    public static function checkUserTaxShippingCountry(User $user, $shipping_country_id) {
     
        if(!$user->account || !$user->account->country_id){
            abort(403, 'Error: User hat kein Land!');
        }
        $ShippingCountry = ShippingCountry::findOrFail($shipping_country_id);
        self::$user_tax_free = self::performUserTaxShippingCountry($user, $ShippingCountry);
        return $ShippingCountry;
        /*
        dump( self::$user_price_code );
        dump( self::$user_tax_free );
        dump( self::$user_reverse_charge );
        */
    }

    public static function performUserTaxShippingCountry($user, $ShippingCountry){
        //preise für das Land
        self::$user_country = $user->account->country;
        self::$shipping_country = $ShippingCountry->country;
        //ausgehend vom Land des Rechnungsempfänger $user->account->country
        //ist der Rechnungsempfänger im Drittland?
        if($user->account->country->supply_country){
            if($ShippingCountry->country->supply_country){
               //Lieferadresse im Drittland?
                return true;
            }
        }
        //Rechnungsempfänger in der EU
        
        //Lieferland mit RSV
        if($ShippingCountry->country->eu_country){
            //Rechnungsempfänger mit valid aktiv RSV
            if($user->account->reverse_charge && $user->account->reverse_charge_valid){
                //Rechnungsland ist auch Lieferland, dann RSV
                if(strtolower($user->account->reverse_charge_code) ==  strtolower($ShippingCountry->country->code)){
                    self::$user_reverse_charge = true;
                    return true;
                }
            }
        } 
        //Lieferland ohne RSV

        return false;
    }

    public static function getYardInfo(){
        return [
            'shipping_free' =>  self::$shipping_free,
            'user_tax_free' => self::$user_tax_free,
            'user_reverse_charge' => self::$user_reverse_charge,
            'user_country_id' => self::$user_country->id,
            'shipping_country_id' =>  self::$shipping_country->id,
        ];
    }

    public static function getTaxFree(){
        return self::$user_tax_free ? true : false;
    }

    public static function getUserPriceInfos(){
        return [
            'user_tax_free' => self::$user_tax_free,
            'user_reverse_charge' => self::$user_reverse_charge,
            'user_country_id' => self::$user_country->id,
        ];
    }

    public static function getShippingCountryNameById($id){
        $country = ShippingCountry::findOrFail($id);
        return $country->country->getLocated();
    }

    public static function getOrderInfo($key = false){
        if(!self::$user_country){
            return '';
        }
        switch ($key) {
            case 'billing_state':
                return self::$user_country->getLocated();
                break;
            case 'shipping_state':
                return self::$shipping_country->getLocated();
                break;
            case 'tax_free':
                return self::$user_tax_free ? __('no') : __('yes');
                break;
            case 'user_reverse_charge':
                return self::$user_reverse_charge ? __('yes') : __('no');                
                break;
           
        }
    }


    public static function hasActivePromotion($user) {
        $promotion_users = PromotionUser::where('user_id', $user->id)->where('active', 1)->whereNull('user_deleted_at')->get();
        foreach($promotion_users as $promotion_user){
            if($promotion_user->promotion_admin->isActive()){
                return true;
            }
        }
        return false;
    }
}